"use strict";

exports.__esModule = true;
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var CustomPropTypes = _interopRequireWildcard(require("./util/PropTypes"));

var _dataHelpers = require("./util/dataHelpers");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

var DropdownListInput =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(DropdownListInput, _React$Component);

  function DropdownListInput() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;
    _this.state = {
      autofilling: false
    };
    _this.search = _react.default.createRef();
    _this.value = _react.default.createRef();

    _this.handleAutofillDetect = function (_ref) {
      var animationName = _ref.animationName;
      var autofilling;
      if (animationName === 'react-widgets-autofill-start') autofilling = true;else if (animationName === 'react-widgets-autofill-cancel') autofilling = false;else return;

      _this.setState({
        autofilling: autofilling
      });

      _this.props.onAutofill(autofilling);
    };

    _this.handleAutofill = function (e) {
      _this.setState({
        autofilling: false
      });

      _this.props.onAutofillChange(e);
    };

    return _this;
  }

  var _proto = DropdownListInput.prototype;

  _proto.focus = function focus() {
    var _this$search$current, _this$value$current;

    if (this.props.allowSearch) (_this$search$current = this.search.current) === null || _this$search$current === void 0 ? void 0 : _this$search$current.focus();else (_this$value$current = this.value.current) === null || _this$value$current === void 0 ? void 0 : _this$value$current.focus();
  };

  _proto.renderInput = function renderInput() {
    var _this$props = this.props,
        placeholder = _this$props.placeholder,
        value = _this$props.value,
        textField = _this$props.textField,
        searchTerm = _this$props.searchTerm,
        onSearch = _this$props.onSearch,
        allowSearch = _this$props.allowSearch,
        Component = _this$props.valueComponent;
    var inputValue = !value && placeholder ? _react.default.createElement("span", {
      className: "rw-placeholder"
    }, placeholder) : Component ? _react.default.createElement(Component, {
      item: value
    }) : (0, _dataHelpers.dataText)(value, textField);
    return _react.default.createElement(_react.default.Fragment, null, allowSearch && _react.default.createElement("input", {
      ref: this.search,
      className: "rw-dropdown-list-search",
      value: searchTerm || '',
      size: (searchTerm || '').length + 2,
      onChange: onSearch
    }), !searchTerm && inputValue);
  };

  _proto.renderAutofill = function renderAutofill() {
    var _this$props2 = this.props,
        name = _this$props2.name,
        autoComplete = _this$props2.autoComplete;
    var value = (0, _dataHelpers.dataValue)(this.props.value);
    return _react.default.createElement("input", {
      tabIndex: "-1",
      name: name,
      value: value == null ? '' : value,
      autoComplete: autoComplete,
      onChange: this.handleAutofill,
      onAnimationStart: this.handleAutofillDetect,
      className: (0, _classnames.default)('rw-dropdown-list-search rw-detect-autofill', !this.state.autofilling && 'rw-sr')
    });
  };

  _proto.render = function render() {
    var autoComplete = this.props.autoComplete;
    var autofilling = this.state.autofilling;
    return _react.default.createElement("div", {
      className: "rw-input rw-dropdown-list-input"
    }, autoComplete !== 'off' && this.renderAutofill(), !autofilling && autoComplete !== 'off' && this.renderInput());
  };

  return DropdownListInput;
}(_react.default.Component);

DropdownListInput.propTypes = {
  value: _propTypes.default.any,
  placeholder: _propTypes.default.string,
  name: _propTypes.default.string,
  autoComplete: _propTypes.default.string,
  textField: CustomPropTypes.accessor,
  valueComponent: CustomPropTypes.elementType,
  onAutofill: _propTypes.default.func.isRequired,
  onAutofillChange: _propTypes.default.func.isRequired
};
var _default = DropdownListInput;
exports.default = _default;
module.exports = exports["default"];